##############################
#
# COPYRIGHT (c) 2007 shagon
# COMPILER:PythonWin
# DEBUG ON Series 60 C++ SDKs
# TESTED ON NOKIA6670
# DATE:Sep 24th,2007
#
##############################
# -*- coding:utf-8 -*- 
import appuifw
import graphics
import e32
import os
import audio
from key_codes import *
appuifw.note('shagon作品\nwww.cnpda.com.cn\nCNPDA编程组\n2007.09.24'.decode("utf-8"), "info")
filename='e:\\system\\apps\\EasyRecord\\record.wav'
def exit():
    global running
    if appuifw.query('确认退出'.decode('utf8'),'query'):
        running=0
        appuifw.app.set_exit()       
appuifw.app.exit_key_handler=exit
class Keyboard(object):
    def __init__(self,onevent=lambda:None):
        self._keyboard_state={}
        self._downs={}
        self._onevent=onevent
    def handle_event(self,event):
        if event['type'] == appuifw.EEventKeyDown:
            code=event['scancode']
            if not self.is_down(code):
                self._downs[code]=self._downs.get(code,0)+1
            self._keyboard_state[code]=1
        elif event['type'] == appuifw.EEventKeyUp:
            self._keyboard_state[event['scancode']]=0
        self._onevent()
    def is_down(self,scancode):
        return self._keyboard_state.get(scancode,0)
    def pressed(self,scancode):
        if self._downs.get(scancode,0):
            self._downs[scancode]-=1
            return True
        return False
keyboard=Keyboard()
running=1
appuifw.app.screen='full'
canvas=appuifw.Canvas(event_callback=keyboard.handle_event, redraw_callback=None)
appuifw.app.body=canvas
canvas.clear()
canvas.text((33,52),u'+==================+',0x000000)
canvas.text((35,62),u'|',0x000000)    
canvas.text((54,64),u'------------',0x000000)    
canvas.text((131,62),u'|',0x000000)    
canvas.text((35,74),u'|',0x000000)
canvas.text((131,74),u'|',0x000000)    
canvas.text((48,74),u'(   )',0x000000)    
canvas.text((100,74),u'(   )',0x000000)
canvas.text((35,86),u'|',0x000000)
canvas.text((131,86),u'|',0x000000)  
canvas.text((54,83),u'------------',0x000000)
canvas.text((35,90),u'|',0x000000)
canvas.text((131,90),u'|',0x000000)     
canvas.text((33,99),u'+---/-o------o-\---+',0x000000)    
canvas.text((57,92),u'~~~~~~~~~',0x000000)
canvas.text((73,116),u'STOP',0x000000)
canvas.text((20,145),u'1: Record',0xff0000)
canvas.text((78,145),u'3: Play',0x0000ff)
canvas.text((122,145),u'5: Stop',0x000000)
def easyrecord():
    global easy
    os.remove(filename)
    easy=audio.Sound.open(filename)
    easy.record()
def easyplay():
    global easy
    easy=audio.Sound.open(filename)
    if easy.state()==audio.EOpen:
        easy.play(1,0)      
def easystop():
    global easy
    easy.stop()
    easy.close()
while running:
    if keyboard.pressed(EScancode5):
        easystop()
        canvas.clear()
        canvas.text((33,52),u'+==================+',0x000000)
        canvas.text((35,62),u'|',0x000000)
        canvas.text((54,64),u'------------',0x000000)
        canvas.text((131,62),u'|',0x000000)
        canvas.text((35,74),u'|',0x000000)
        canvas.text((131,74),u'|',0x000000)
        canvas.text((48,74),u'(   )',0x000000)
        canvas.text((100,74),u'(   )',0x000000)
        canvas.text((35,86),u'|',0x000000)
        canvas.text((131,86),u'|',0x000000)
        canvas.text((54,83),u'------------',0x000000)
        canvas.text((35,90),u'|',0x000000)
        canvas.text((131,90),u'|',0x000000)
        canvas.text((33,99),u'+---/-o------o-\---+',0x000000)
        canvas.text((57,92),u'~~~~~~~~~',0x000000)
        canvas.text((73,116),u'STOP',0x000000)
        canvas.text((20,145),u'1: Record',0xff0000)
        canvas.text((78,145),u'3: Play',0x0000ff)
        canvas.text((122,145),u'5: Stop',0x000000)
    if keyboard.pressed(EScancode1):
        easyrecord()
        canvas.clear()
        canvas.text((33,52),u'+==================+',0xff0000)
        canvas.text((35,62),u'|',0xff0000)
        canvas.text((54,64),u'------------',0xff0000)
        canvas.text((131,62),u'|',0xff0000)
        canvas.text((35,74),u'|',0xff0000)
        canvas.text((131,74),u'|',0xff0000)
        canvas.text((48,74),u'(   )',0xff0000)
        canvas.text((100,74),u'(   )',0xff0000)
        canvas.text((35,86),u'|',0xff0000)
        canvas.text((131,86),u'|',0xff0000)
        canvas.text((54,83),u'------------',0xff0000)
        canvas.text((35,90),u'|',0xff0000)
        canvas.text((131,90),u'|',0xff0000)
        canvas.text((33,99),u'+---/-o------o-\---+',0xff0000)
        canvas.text((57,92),u'~~~~~~~~~',0xff0000)
        canvas.text((67,116),u'RECORD',0xff0000)
        canvas.text((20,145),u'1: Record',0xff0000)
        canvas.text((78,145),u'3: Play',0x0000ff)
        canvas.text((122,145),u'5: Stop',0x000000)        
    if keyboard.pressed(EScancode3):
        easyplay()
        canvas.clear()
        canvas.text((33,52),u'+==================+',0x0000ff)
        canvas.text((35,62),u'|',0x0000ff)
        canvas.text((54,64),u'------------',0x0000ff)
        canvas.text((131,62),u'|',0x0000ff)
        canvas.text((35,74),u'|',0x0000ff)
        canvas.text((131,74),u'|',0x0000ff)
        canvas.text((48,74),u'(   )',0x0000ff)
        canvas.text((100,74),u'(   )',0x0000ff)
        canvas.text((35,86),u'|',0x0000ff)
        canvas.text((131,86),u'|',0x0000ff)
        canvas.text((54,83),u'------------',0x0000ff)
        canvas.text((35,90),u'|',0x0000ff)
        canvas.text((131,90),u'|',0x0000ff)
        canvas.text((33,99),u'+---/-o------o-\---+',0x0000ff)
        canvas.text((57,92),u'~~~~~~~~~',0x0000ff)
        canvas.text((73,116),u'PLAY',0x0000ff)
        canvas.text((20,145),u'1: Record',0xff0000)
        canvas.text((78,145),u'3: Play',0x0000ff)
        canvas.text((122,145),u'5: Stop',0x000000)           
    e32.ao_yield()
app_lock = e32.Ao_lock()
app_lock.wait()